unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    TimerTarget: TTimer;
    Panel1: TPanel;
    ImgMsg: TImage;
    EditBurstCount: TEdit;
    EditBurstSleep: TEdit;
    UpdBurstCount: TUpDown;
    UpdBurstSleep: TUpDown;
    Label3: TLabel;
    Label4: TLabel;
    BtnAbout: TBitBtn;
    BtnHelp: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ImgMsgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimerTargetTimer(Sender: TObject);
    procedure ImgMsgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EditBurstCountChange(Sender: TObject);
    procedure EditBurstSleepChange(Sender: TObject);
    procedure BtnAboutClick(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
  private
    InMouseDown: Boolean;
    procedure CancelBurst();
    procedure DispMode(const Mode: integer);
  protected
    procedure WndProc(var Msg: TMessage); override;
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    iMisc, Info;

var
    TargetHandle: HWND = INVALID_HANDLE_VALUE;
    TargetParent: HWND = INVALID_HANDLE_VALUE;
    BurstCount: integer = 0;
    BurstSleep: integer = 0;
    ClickCount: integer = 0;

//------------------------------------------------------------------------------
procedure InfoOk(const S: string);
var F: integer;
begin
    F := MB_OK + MB_ICONINFORMATION;
    Application.MessageBox(PChar(S), PChar(Application.Title), F);
end;

//  ===========================================================================
//  o[Xg񐔐ݒ
procedure TMainForm.EditBurstCountChange(Sender: TObject);
begin
    BurstCount := UpdBurstCount.Position;
end;

//  ===========================================================================
//  o[XgC^[oݒ
procedure TMainForm.EditBurstSleepChange(Sender: TObject);
begin
    BurstSleep := UpdBurstSleep.Position;
end;

//  ===========================================================================
//  NbNXbh
type
    TClicker = class(TThread)
    private
        procedure DoClick();
    protected
        procedure Execute; override;
    public
        constructor Create();
    end;
//  ---------------------------------------------------------------------------
var Clicker: TClicker = nil;
//  ---------------------------------------------------------------------------
//  RXgN^
constructor TClicker.Create();
begin
    inherited Create(true);
    Priority := tpNormal;
    Resume();
end;
//  ---------------------------------------------------------------------------
//  NbNs
procedure TClicker.DoClick();
begin
    if SimulateClick(TargetHandle, BurstSleep) then
        Dec(ClickCount)
    else
        ClickCount := 0
    ;
end;
//  ---------------------------------------------------------------------------
//  [văNbN邩ǂĎ
procedure TClicker.Execute();
var
    SleepCount: integer;
begin
    while not Terminated do
    begin
        if ClickCount > 0 then
        begin
            SleepCount := 0;
            Synchronize(DoClick);
        end
        else
            SleepCount := 1;
        ;
        Sleep(SleepCount);
    end;
end;

//  ===========================================================================
//  RXgN^
//  ---------------------------------------------------------------------------
//  http://www.borland.co.jp/tips/delphi/dh008/
//  http://forum.nifty.com/fdelphi/faq/00289.htm
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  ^Cgݒ
    Self.Caption := Application.Title + ' - ' + Self.Name;

    DispMode(MODE_NONE);

    //  Lv`łȂ
    InMouseDown := false;

    //  o[Xg
    UpdBurstCount.Position := 2;
    UpdBurstSleep.Position := 1;

    //  tbN
    HookInitialize();
    //  tbNCXg[
    HookInstall(Self.Handle);
end;

//  ===========================================================================
//  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  tbNACXg[
    HookUnInstall();
    //  tbNn
    HookFinalize();
end;

//  ===========================================================================
//  \
procedure TMainForm.DispMode(const Mode: integer);
var
    s1: string;
begin
    case Mode of
    MODE_LOCKON:
        begin
            ImgMsg.Picture.Bitmap.LoadFromResourceName(HInstance, BMP_LOCK);
            s1 := Format(' %d:%s(%s)', [TargetHandle, GetClassNameStr(TargetHandle), GetWindowTextStr(TargetHandle)]);
            s1 := Format('%d:%s(%s)'#13#10'%s', [TargetParent, GetClassNameStr(TargetParent), GetWindowTextStr(TargetParent), s1]);
        end;
    MODE_LOST:
        begin
            ImgMsg.Picture.Bitmap.LoadFromResourceName(HInstance, BMP_LOST);
            s1 := '';
        end;
    else
        begin
            ImgMsg.Picture.Bitmap.LoadFromResourceName(HInstance, BMP_NONE);
            s1 := '';
        end;
    end;
    ImgMsg.Hint := s1;
end;

//  ===========================================================================
//  ^[QbgEBhE擾̗Jn
procedure TMainForm.ImgMsgMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Button = mbLeft) then
    begin
        InMouseDown := true;
        CancelBurst();
        DispMode(MODE_NONE);
        Screen.Cursor := CUR_SEEKER;
    end
    else
    begin
        if (TargetParent <> INVALID_HANDLE_VALUE) then
        begin
            //  EBhE擾
            if not IsWindow(TargetHandle) then
            begin
                CancelBurst();
                DispMode(MODE_NONE);
            end
            else
            begin
                FlashDesktopCanvas2(TargetHandle, 200);
            end;
        end;
    end;
end;

//  ===========================================================================
//  łHłH
procedure TMainForm.TimerTargetTimer(Sender: TObject);
var
    WH, WH2: HWND;
begin
    //  ҋ@
    if (not InMouseDown) then
    begin
        //  Ƀ^[Qbg
        if (TargetHandle <> INVALID_HANDLE_VALUE) then
        begin
            //  ݃`FbN
            if not IsWindow(TargetHandle) then
            begin
                CancelBurst();
                DispMode(MODE_LOST);
            end;
        end;
    end
    //  XpC
    else
    begin
        //  ?
        if (GetAsyncKeyState(VK_ESCAPE) <> 0) then
        begin
            InMouseDown := false;
            Screen.Cursor := crDefault;
            Exit;
        end;
        //  }EẌʒũEBhEnh擾
        WH := WindowFromPoint(Mouse.CursorPos);
        //  ̃EBhẼgbvx̐ẽnh擾
        WH2 := GetMostTopLevelWindow(WH);
        //  Ȃ낤˂
        if (WH2 = GetMostTopLevelWindow(Self.Handle)) then Exit;
        //  
        FlashDesktopCanvas(WH, 100);
    end;
end;

//  ===========================================================================
//  ^[QbgEBhE擾̗I
//  ---------------------------------------------------------------------------
//  http://forum.nifty.com/fdelphi/samples/00495.html
procedure TMainForm.ImgMsgMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  XpCłȂ΃XLbv
    if InMouseDown then
    begin
        //  tO|ăJ[\ɖ߂
        InMouseDown := false;
        Screen.Cursor := crDefault;
        //  }EX̃EBhEnho
        TargetHandle := WindowFromPoint(Mouse.CursorPos);
        TargetParent := GetMostTopLevelWindow(TargetHandle);
        //  Ȃ낤˂
        if (TargetParent = GetMostTopLevelWindow(Self.Handle)) then
        begin
            CancelBurst();
            DispMode(MODE_NONE);
            Exit;
        end;
        DispMode(MODE_LOCKON);
    end;
end;

//  ===========================================================================
//  bNI
procedure TMainForm.CancelBurst();
begin
    ClickCount := 0;
    TargetHandle := INVALID_HANDLE_VALUE;
    TargetParent := INVALID_HANDLE_VALUE;
    DispMode(MODE_NONE);
end;

//  ===========================================================================
//  EBhEvV[W
procedure TMainForm.WndProc(var Msg: TMessage);
var
    WParamHW: HWND; 
begin
    //  LXg
    WParamHW := HWND(Msg.WParam);

    case Msg.Msg of
    //  EBhEj
    UM_DESTROYWND:
        begin
            if (WParamHW = TargetParent) then
            begin
                CancelBurst();
                DispMode(MODE_LOST);
            end;
        end;

    //  {^グ
    UM_LMOUSEUP,
    //  E{^グ
    UM_RMOUSEUP:
        begin
            if (WParamHW = TargetHandle) then
            begin
                ClickCount := BurstCount;
            end;
        end;
    end;

    inherited;
end;

//  ===========================================================================
//  AoEg
procedure TMainForm.BtnAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//  ===========================================================================
//  wv
procedure TMainForm.BtnHelpClick(Sender: TObject);
var
    s: string;
begin
    s := ''
       + '[BURST CLICK] 摜̐'
       + #13#10#9'}EX{^Ń^[Qbg胂[hɈڍs܂B'
       + #13#10#9'^[QbgŃ}EX𗣂ƃbNI܂B'
       + #13#10
       + #13#10'[!!! LOCK ON !!!] 摜̐'
       + #13#10#9'^[QbgNbNƃo[XgNbN܂B'
       + #13#10#9'}EXE{^NbNŃ^[Qbg_ł܂B'
       + #13#10#9'}EX{^NbNŃ^[Qbg[X܂B'
       + #13#10
       + #13#10'[TARGET LOST] 摜̐'
       + #13#10#9'^[QbgƂ͎Ń[X܂B'
       + #13#10
       + #13#10'Clicks ̐'
       + #13#10#9'Ŏw肵񐔂ǉNbN(o[XgNbN)܂B'
       + #13#10
       + #13#10'Interval ̐'
       + #13#10#9'o[Xg̃NbNƃNbN̊Ԃɓu҂(msec)vw肵܂B'
       ;
    InfoOk(s);
end;

//  ===========================================================================
//  EI
initialization
    Clicker := TClicker.Create();
finalization
    Clicker.Terminate();
    Clicker.Free;
end.

